# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           hamcrest13
Version:        1.3
Release:	2%{?dist}
Epoch:          0
Summary:        Library of matchers for building test expressions
License:        BSD
URL:            http://code.google.com/p/hamcrest/
Group:          Development/Tools
Source0:        hamcrest-java-1.3.tar.bz2
# git clone https://github.com/hamcrest/JavaHamcrest.git
# git tag -l
# git archive --prefix="hamcrest-java-1.3/" --format=tar hamcrest-java-1.3 | bzip2 > ../../SOURCES/hamcrest-java-1.3.tar.bz2

Source1:        http://repo1.maven.org/maven2/org/hamcrest/hamcrest-parent/1.3/hamcrest-parent-1.3.pom
Source2:        http://repo1.maven.org/maven2/org/hamcrest/hamcrest-library/1.3/hamcrest-library-1.3.pom
Source3:        http://repo1.maven.org/maven2/org/hamcrest/hamcrest-integration/1.3/hamcrest-integration-1.3.pom
Source4:        http://repo1.maven.org/maven2/org/hamcrest/hamcrest-generator/1.3/hamcrest-generator-1.3.pom
Source5:        http://repo1.maven.org/maven2/org/hamcrest/hamcrest-core/1.3/hamcrest-core-1.3.pom
Source6:        http://repo1.maven.org/maven2/org/hamcrest/hamcrest-all/1.3/hamcrest-all-1.3.pom
Requires:       java >= 0:1.6.0
Requires:       easymock2
Requires:       jmock
Requires:       qdox >= 0:1.12
Requires:       qdox161
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7
BuildRequires:  ant-junit
BuildRequires:  aqute-bndlib
BuildRequires:  easymock2
BuildRequires:  jarjar
BuildRequires:  jmock
BuildRequires:  junit
BuildRequires:  junit4
BuildRequires:  qdox >= 0:1.12
BuildRequires:  qdox161
BuildRequires:  testng
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

Buildarch:      noarch

Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%description
Provides a library of matcher objects (also known as constraints or predicates)
allowing 'match' rules to be defined declaratively, to be used in other
frameworks. Typical scenarios include testing frameworks, mocking libraries and
UI validation rules.

%package devel
Group:          Source archives
Summary:        Source archives for %{name}

%description devel
%{summary}.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%package demo
Group:          Development/Libraries
Summary:        Demos for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       junit
Requires:       junit4
Requires:       testng

%description demo
Demonstrations and samples for %{name}.

%prep
%setup -q -n hamcrest-java-%{version}
for j in $(find . -type f -name "*.jar"); do
    mv $j $j.no
done
#%%patch0 -b .sav0
#BUILD/hamcrest-java-1.3/lib/generator/jarjar-1.3.jar.no
ln -sf $(build-classpath jarjar) lib/generator/jarjar-1.3.jar
#mv lib/generator/jarjar-1.0rc3.jar.no lib/generator/jarjar-1.0rc3.jar
#BUILD/hamcrest-java-1.3/lib/generator/qdox-1.12.jar.no
ln -sf $(build-classpath qdox) lib/generator/qdox-1.12.jar
#BUILD/hamcrest-java-1.3/lib/generator/qdox-1.6.1.jar.no
ln -sf $(build-classpath qdox161) lib/generator/qdox-1.6.1.jar
#mv lib/generator/qdox-1.6.1.jar.no lib/generator/qdox-1.6.1.jar
#BUILD/hamcrest-java-1.3/lib/integration/easymock-2.2.jar.no
ln -sf $(build-classpath easymock2) lib/integration/easymock-2.2.jar
#mv lib/integration/easymock-2.2.jar.no lib/integration/easymock-2.2.jar
#BUILD/hamcrest-java-1.3/lib/integration/jmock-1.10RC1.jar.no
ln -sf $(build-classpath jmock) lib/integration/jmock-1.10RC1.jar
#mv lib/integration/jmock-1.10RC1.jar.no lib/integration/jmock-1.10RC1.jar
#BUILD/hamcrest-java-1.3/lib/integration/junit-3.8.1.jar.no
ln -sf $(build-classpath junit) lib/integration/junit-3.8.1.jar
#mv lib/integration/junit-3.8.1.jar.no lib/integration/junit-3.8.1.jar
#BUILD/hamcrest-java-1.3/lib/integration/junit-dep-4.10.jar.no
#ln -sf $(build-classpath junit4) lib/integration/junit-dep-4.10.jar
mv lib/integration/junit-dep-4.10.jar.no lib/integration/junit-dep-4.10.jar
#BUILD/hamcrest-java-1.3/lib/integration/testng-6.5.2.jar.no
ln -sf $(build-classpath testng) lib/integration/testng-6.5.2.jar
#mv lib/integration/testng-6.5.2.jar.no lib/integration/testng-6.5.2.jar

perl -pi -e 's/\r$//g' LICENSE.txt

%build
ant -Dversion=%{version} unit-test bigjar examples javadoc

# added some osgi bundling
cat > build/core.properties <<EOP
Bundle-Version: 1.3.0
Bundle-SymbolicName: org.hamcrest.core
EOP
java -jar $(build-classpath aqute-bndlib) wrap -properties build/core.properties build/hamcrest-core-%{version}.jar
cp build/hamcrest-core-%{version}.bar build/%{name}-core-%{version}.jar

cat > build/generator.properties <<EOP
Bundle-Version: 1.3.0
Bundle-SymbolicName: org.hamcrest.generator
EOP
java -jar $(build-classpath aqute-bndlib) wrap -properties build/generator.properties build/hamcrest-generator-%{version}.jar
cp build/hamcrest-generator-%{version}.bar build/%{name}-generator-%{version}.jar

cat > build/integration.properties <<EOP
Bundle-Version: 1.3.0
Bundle-SymbolicName: org.hamcrest.integration
EOP
java -jar $(build-classpath aqute-bndlib) wrap -properties build/integration.properties build/hamcrest-integration-%{version}.jar
cp build/hamcrest-integration-%{version}.bar build/%{name}-integration-%{version}.jar

cat > build/library.properties <<EOP
Bundle-Version: 1.3.0
Bundle-SymbolicName: org.hamcrest.library
EOP
java -jar $(build-classpath aqute-bndlib) wrap -properties build/library.properties build/hamcrest-library-%{version}.jar
cp build/hamcrest-library-%{version}.bar build/%{name}-library-%{version}.jar

cat > build/examples.properties <<EOP
Bundle-Version: 1.3.0
Bundle-SymbolicName: org.hamcrest.examples
EOP
java -jar $(build-classpath aqute-bndlib) wrap -properties build/examples.properties build/hamcrest-examples-%{version}.jar
cp build/hamcrest-examples-%{version}.bar build/%{name}-examples-%{version}.jar

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom
%add_to_maven_depmap org.hamcrest hamcrest-parent %{version} JPP/%{name} parent

install -m 644 build/hamcrest-all-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/all-%{version}.jar
install -m 644 build/hamcrest-all-%{version}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/all-sources-%{version}.jar
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-all.pom
%add_to_maven_depmap org.hamcrest hamcrest-all %{version} JPP/%{name} all

install -m 644 build/hamcrest-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 build/hamcrest-core-%{version}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/core-sources-%{version}.jar
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core.pom
%add_to_maven_depmap org.hamcrest hamcrest-core %{version} JPP/%{name} core

install -m 644 build/hamcrest-generator-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/generator-%{version}.jar
install -m 644 build/hamcrest-generator-%{version}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/generator-sources-%{version}.jar
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-generator.pom
%add_to_maven_depmap org.hamcrest hamcrest-generator %{version} JPP/%{name} generator

install -m 644 build/hamcrest-library-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/library-%{version}.jar
install -m 644 build/hamcrest-library-%{version}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/library-sources-%{version}.jar
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-library.pom
%add_to_maven_depmap org.hamcrest hamcrest-library %{version} JPP/%{name} library

install -m 644 build/hamcrest-integration-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-%{version}.jar
install -m 644 build/hamcrest-integration-%{version}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-sources-%{version}.jar
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-integration.pom
%add_to_maven_depmap org.hamcrest hamcrest-integration %{version} JPP/%{name} integration

install -m 644 build/hamcrest-unit-test-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/unit-test-%{version}.jar
install -m 644 build/hamcrest-unit-test-%{version}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/unit-test-sources-%{version}.jar

pushd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done
popd

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/temp/hamcrest-all-1.3-javadoc.jar.contents/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# demo
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -m 644 build/%{name}-examples-%{version}.jar $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr hamcrest-examples $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_datadir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/all-%{version}.jar
%{_javadir}/%{name}/all.jar
%{_javadir}/%{name}/core-%{version}.jar
%{_javadir}/%{name}/core.jar
%{_javadir}/%{name}/generator-%{version}.jar
%{_javadir}/%{name}/generator.jar
%{_javadir}/%{name}/integration-%{version}.jar
%{_javadir}/%{name}/integration.jar
%{_javadir}/%{name}/library-%{version}.jar
%{_javadir}/%{name}/library.jar
%{_javadir}/%{name}/unit-test-%{version}.jar
%{_javadir}/%{name}/unit-test.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files devel
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/all-sources-%{version}.jar
%{_javadir}/%{name}/all-sources.jar
%{_javadir}/%{name}/core-sources-%{version}.jar
%{_javadir}/%{name}/core-sources.jar
%{_javadir}/%{name}/generator-sources-%{version}.jar
%{_javadir}/%{name}/generator-sources.jar
%{_javadir}/%{name}/integration-sources-%{version}.jar
%{_javadir}/%{name}/integration-sources.jar
%{_javadir}/%{name}/library-sources-%{version}.jar
%{_javadir}/%{name}/library-sources.jar
%{_javadir}/%{name}/unit-test-sources-%{version}.jar
%{_javadir}/%{name}/unit-test-sources.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}
%{_datadir}/%{name}

%changelog
* Tue Feb 05 2013 Ralph Apel <r.apel@r-apel.de> 1.3-2
- Prevent xzpayload problem

* Sun Jan 13 2013 Ralph Apel <r.apel@r-apel.de> 1.3-1
- 1.3 final as hamcrest13
- add -devel subpackage with -sources.jar archives

* Sun Jun 17 2012 Ralph Apel <r.apel@r-apel.de> 1.3-0.rc2.2
- Avoid FileDigest and PayloadIsXz problems on EL5

* Sun Feb 19 2012 Ralph Apel <r.apel@r-apel.de> 1.3-0.rc2.1
- 1.3 as hamcrest13

* Sat Nov 26 2011 Ralph Apel <r.apel@r-apel.de> 1.1-10
- Rebuild to upload missing binary rpms

* Tue Oct 12 2010 Ralph Apel <r.apel@r-apel.de> 1.1-9
- Adapt for JPackage 6
- Add some osgi bundling with command line bnd

* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 1.1-8
- Auto rebuild for JPackage 5 in mock

* Mon Nov 24 2008 David Walluck <dwalluck@redhat.com> 0:1.1-7
- update summary and description

* Tue Oct 28 2008 David Walluck <dwalluck@redhat.com> 0:1.1-6
- make demo dependency on testng conditional

* Fri Oct 24 2008 David Walluck <dwalluck@redhat.com> 0:1.1-5
- fix GCJ file list
- simplify build by always setting OPT_JAR_LIST

* Fri Oct 24 2008 David Walluck <dwalluck@redhat.com> 0:1.1-4
- add epoch to demo Requires

* Fri Oct 24 2008 David Walluck <dwalluck@redhat.com> 0:1.1-3
- set -Dant.build.javac.source=1.5

* Fri Oct 24 2008 David Walluck <dwalluck@redhat.com> 0:1.1-2
- add options to build without integration, jarjar, and tests
- allow build with java-devel >= 1.5.0
- remove javadoc scriptlets
- use more strict file list
- fix maven directory ownership
- add non-versioned symlink for demo
- fix GCJ requires
- fix eol in LICENSE.txt
- remove Vendor and Distribution

* Tue Feb 19 2008 Ralph Apel <r.apel@r-apel.de> - 0:1.1-1jpp
- 1.1

* Mon Feb 11 2008 Ralph Apel <r.apel@r-apel.de> - 0:4.3.1-4jpp
- Fix versioned jar name, was junit-4.3.1
- Restore Epoch

* Fri Jan 25 2008 Ralph Apel <r.apel@r-apel.de> - 0:4.3.1-3jpp
- build and upload noarch packages
- Add pom and depmap frag
- BR java-devel = 1.5.0
- Restore Vendor, Distribution from macros

* Tue Aug 07 2007 Ben Konrath <bkonrath@redhat.com> - 4.3.1-2jpp
- Set gcj_support to 0 to work around problems with GCJ.
- Fix buglet with the gcj post/postun if statement.
- Fix tab / space problems.
- Fix buildroot.
- Update Summary.
- Convert html files to Unix file endings.
- Disable aot-compile-rpm because it's not working ATM.

* Mon Jul 09 2007 Ben Konrath <bkonrath@redhat.com> - 4.3.1-1jpp
- 4.3.1.

* Mon Feb 12 2007 Thomas Fitzsimmons <fitzsim@redhat.com> - 3.8.2-3jpp.1.fc7
- Add dist tag

* Mon Feb 12 2007 Thomas Fitzsimmons <fitzsim@redhat.com> - 3.8.2-3jpp.1
- Committed on behalf of Tania Bento <tbento@redhat.com>
- Update per Fedora review process
- Resolves rhbz#225954

* Thu Aug 10 2006 Deepak Bhole <dbhole@redhat.com> -  0:3.8.2-3jpp.1
- Added missing requirements.

* Thu Aug 10 2006 Karsten Hopp <karsten@redhat.de> 0:3.8.2-2jpp_3fc
- Require(post/postun): coreutils

* Sun Jun 23 2006 Deepak Bhole <dbhole@redhat.com> -  0:3.8.2-2jpp_2fc
- Rebuilt.

* Sat Jun 22 2006 Deepak Bhole <dbhole@redhat.com> -  0:3.8.2-2jpp_1fc
- Upgrade to 3.8.2
- Added conditional native compilation.
- Fix path where demo is located.

* Mon Mar 03 2006 Ralph Apel <r.apel at r-apel.de> - 0:3.8.2-1jpp
- First JPP-1.7 release

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:3.8.1-4jpp
- Rebuild with ant-1.6.2
* Fri May 09 2003 David Walluck <david@anti-microsoft.org> 0:3.8.1-3jpp
- update for JPackage 1.5

* Fri Mar 21 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 3.8.1-2jpp
- For jpackage-utils 1.5

* Fri Sep 06 2002 Henri Gomez <hgomez@users.sourceforge.net> 3.8.1-1jpp
- 3.8.1

* Sun Sep 01 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 3.8-2jpp 
- used original zip file

* Thu Aug 29 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 3.8-1jpp 
- 3.8
- group, vendor and distribution tags

* Sat Jan 19 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 3.7-6jpp
- versioned dir for javadoc
- no dependencies for manual and javadoc packages
- stricter dependency for demo package
- additional sources in individual archives
- section macro

* Sat Dec 1 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 3.7-5jpp
- javadoc in javadoc package

* Wed Nov 21 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 3.7-4jpp
- fixed previous releases ...grrr

* Wed Nov 21 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 3.7-3jpp
- added jpp extension
- removed packager tag

* Sun Sep 30 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 3.7-2jpp
- first unified release
- s/jPackage/JPackage

* Mon Sep 17 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 3.7-1mdk
- 3.7
- vendor tag
- packager tag
- s/Copyright/License/
- truncated description to 72 columns in spec
- spec cleanup
- used versioned jar
- moved demo files to %%{_datadir}/%%{name}

* Sat Feb 17 2001 Guillaume Rousse <g.rousse@linux-mandrake.com> 3.5-1mdk
- first Mandrake release
